/*
 * @Author: your name
 * @Date: 2021-09-18 10:21:34
 * @LastEditTime: 2022-01-19 13:34:23
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: /RM/roadmodel/modules/common/road/frame.cc
 */

/**
 * @file frame.cc
 **/
#include "frame.h"

#include "lane.h"
#include <algorithm>
#include <limits>

#include "glog/logging.h"
namespace rm {

using rm::common::ErrorCode;
using rm::common::Status;

Frame::Frame(uint32_t sequence_num) : sequence_num_(sequence_num) {}

Frame::Frame(uint32_t sequence_num, const LocalView &local_view,
             RoadInfoProvider *road_info_provider)
    : sequence_num_(sequence_num), local_view_(local_view),
      road_info_provider_(road_info_provider), traffic_road_input_status_(true),
      objects_input_status_(true) {}

Status Frame::Init(const std::list<Lane> &lanes) {
  //更新其他输入信息
    auto status = InitFrameData();
    if (!status.ok()) {
    // DLOG(ERROR) << "failed to init frame:" << status.ToString();
    return status;
  }
  //创建lane_info
    if (!CreateLaneInfo(lanes)) {
    traffic_road_input_status_ = false;
    const std::string msg = "Failed to init lane info.";
    // DLOG(WARNING) << msg;
  }
    if (road_info_provider_->mutable_objects_cem_header()->status().test(0)) {
    objects_input_status_ = false;
    const std::string msg = "Failed to init objects info.";
    // DLOG(WARNING) << msg;
  }
    return Status::OK();
}

uint32_t Frame::SequenceNum() const { return sequence_num_; }

std::list<LaneInfo> *Frame::mutable_lane_info() { return &lane_info_; }

RoadInfoProvider *Frame::road_info_provider() { return road_info_provider_; }
// const VehicleStateProvider *Frame::vehicle_state_provider() const{
//   return vehicle_state_provider_;
// }

const LocalView &Frame::local_view() const { return local_view_; }

Status Frame::InitFrameData() {

  ilc_info_.mutable_ilc_target_id_list()->clear();
  // TODO（ningmeng）后期更新障碍物信息 直接从frame的localview中更新

  // TODO（ningmeng）更新交通灯信息

  return Status::OK();
}

bool Frame::CreateLaneInfo(const std::list<Lane> &lanes) {
  lane_info_.clear();
  auto lane_iter = lanes.begin();
  while (lane_iter != lanes.end()) {
    lane_info_.emplace_back(*lane_iter);
    ++lane_iter;
  }
  return !lane_info_.empty();
}

ILCInfo *Frame::mutable_ilc_info() { return &ilc_info_; }

} // namespace rm
